unit UnitEco;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls ;

type
  TFormEco = class(TForm)
    tmrTick: TTimer;
    procedure tmrTickTimer(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private    
    { Private declarations }
    procedure DeactivateScrnSaver(var Msg : TMsg; var Handled : boolean);
  public

  end;
Function IsPrevInstance:HWND;
var
  FormEco: TFormEco;
  h : thandle;
  p : trect;


implementation

{$R *.DFM}

uses
  UnitConfig;

var
  PosCurseur : TPoint; //pour pouvoir mmoriser la position du curseur

Function IsPrevInstance:HWND;
// cette fonction renvoie 0 s'il n'y a pas d'instance du mme programme dj lance sinon
//le handle de l'instance dj lance c'est  dire une valeur <>0
// cette fonction est appel dans le source du projet. voir ce source pour comprendre
Var ClassName:Array[0..255] of char;
    TitreApplication:string;
Begin
  result:=0;
  TitreApplication:=Application.Title;
  Application.Title:='';  // on change le titre car sinon, on trouverait toujours une application dj lance (la notre!)
  try
    GetClassName(Application.handle, ClassName, 254); //met dans ClassName le nom de la class de l'application ('TApplication' en Delphi3)
    result:=FindWindow(ClassName,PChar(TitreApplication));// renvoie le Handle de la premire fentre de Class (type) ClassName et de titre TitreApplication (0 s'il n'y en a pas)
  if (result <> 0) and (copy(paramstr(1),2,1) <> 's')
  then // le mode aperu se trouve dans le petit cran !!
  begin
    sendmessage(result,wm_close,0,0); // on arrte le mode petit cran !
    result := 0;                      // on autorise le lancement avec le nouveau paramtre
  end;
  finally
    Application.Title:=TitreApplication; // restauration du vrai titre
  end;
end;

procedure TFormEco.DeactivateScrnSaver(var Msg : TMsg; var Handled : boolean);
var
  done : boolean;
begin
  if (Msg.message = WM_MOUSEMOVE)  then
    done := (Abs(LOWORD(Msg.lParam) - PosCurseur.x) > 5) or
            (Abs(HIWORD(Msg.lParam) - PosCurseur.y) > 5)
  else
    done := (Msg.message = WM_KEYDOWN)     or (Msg.message = WM_KEYUP)       or
            (Msg.message = WM_SYSKEYDOWN)  or (Msg.message = WM_SYSKEYUP)    or
            (Msg.message = WM_ACTIVATE)    or (Msg.message = WM_NCACTIVATE)  or
            (Msg.message = WM_ACTIVATEAPP) or (Msg.message = WM_LBUTTONDOWN) or
            (Msg.message = WM_RBUTTONDOWN) or (Msg.message = WM_MBUTTONDOWN);
  if done and not (copy(paramstr(1),2,1) = 'p') then // si on est pas dans le cas de la petite fentre
  begin
    Update;
    close;
  end;
end;



procedure TFormEco.tmrTickTimer(Sender: TObject);
Var Pt: Tpoint;
    p1 : trect;
begin
 // si on est dans le mode visu tl et que l'on clique dans la fentre
 // de configuration ou que l'on quitte celle-ci, alors on ferme tout
  if (copy(paramstr(1),2,1) = 'p') and ((not focused) or (not GetWindowRect(h,p1))) then close;
  Pt.x:=Random(Width); Pt.Y:=Random(Height);
  Canvas.PenPos:=Pt;
  if copy(paramstr(1),2,1) <> 'p' then
    Canvas.Pen.Width:=FormConfig.spnEpaisseur.Value
  else
    Canvas.Pen.Width:=round(FormConfig.spnEpaisseur.Value/10);
  Canvas.Pen.Color:=RGB(random(254),random(254),random(254));
  Canvas.LineTo(random(Width),Random(Height));
end;

procedure TFormEco.FormShow(Sender: TObject);
begin
  GetCursorPos(PosCurseur);
  tmrTick.Interval      := 1000 - FormConfig.spnVitesse.Value;
  tmrTick.Enabled       := true;
  Application.OnMessage := DeactivateScrnSaver;
  if copy(paramstr(1),2,1) = 's' then
  begin
    ShowCursor(false);  // rends inactif le curseur
  end;
  ShowWindow(Application.Handle, SW_Hide); //cache l'icone dans la barre des tches
end;

procedure TFormEco.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Application.OnMessage := nil;
  tmrTick.Enabled       := false;
  ShowCursor(true);
end;

procedure TFormEco.FormActivate(Sender: TObject);
begin
  //si le premier paramtre pass  l'application vaut '/p' alors,on est dans le cas 
  //d'une excution dans la petite fentre de proprit de l'affichage / cran de veille
  if copy(paramstr(1),2,1) = 'p' then
  begin
      h:= StrToInt(paramstr(2)); // le handle de la zone de dessin est pass en paramtre  l'application (second paramtre)
      GetWindowRect(h,p);  // rcup du rectangle
      formEco.Top := p.Top;
      formEco.Left:= p.Left;
      formEco.Width:=p.Right-left;
      formEco.Height:= p.Bottom-p.Top;
  end else
  begin
    WindowState := wsMaximized;
  end;
end;
end.
